Analyse Kontrollflussgraph
---
Im Zuge eines {{White}}-Box Tests
---
Anweisungsüberdeckung
---
> Alle möglichen Anweisungen müssen einmal ausgeführt werden

Codebeispiel:

```Python
def add(number1, number2):
  if (number1 != null)
    if (number2 != null)
      return number1 + number2
  return 0
```

```Python
def testAdd():
  assert add(5,3) == 8     # Anweisungsüberdeckung = 50%
  assert add(null,3) == 0  # Anweisungsüberdeckung = 100% 
  
---
Bedingungsüberdeckung
---
> Alle Auswertungen aller elementaren Bedingungen müssen einmal true und einmal false ergeben

```Python
def add(number1, number2):
  if (number1 != null)
    if (number2 != null)
      return number1 + number2
  return 0
```

```Python
def testAdd():
  assert add(5, 3) == 8        # Bedingungsüberdeckung = 25%
  assert add(null, 3) == 0     # Bedingungsüberdeckung = 50% 
  assert add(3, null) == 0     # Bedingungsüberdeckung = 75%
  assert add(null, null) == 0  # Bedingungsüberdeckung = 100%
---
Pfadüberdeckung
---
> Programm muss alle möglichen Pfade nehmen

-> Vollständige Pfadabdeckung bei Schleifen de facto unmöglich
-> Wird zB in IntelliJ nicht unterstützt (https://www.jetbrains.com/help/idea/running-test-with-coverage.html)