Kreativfragen

Bezieht sich auf Hotel Beispiel, siehe [https://vowi.fsinf.at/images/6/66/TU_Wien-Software_Engineering_und_Projektmanagement_VO_%28Grechenig%29_-_Pr%C3%BCfung_2020-06-24.pdf]

(Take Answers with huge grain of salt, wrote this before reading other answers lmao)
---
**In Ihrer Rolle als ProjektleiterIn haben Sie die Aufgabe das Projekt in 6 Monaten abzuschließen. Skizzieren Sie das aus Ihrer Sicht optimale Projektteam! (Größe, Expertisen, ...) Welchen Softwareentwicklungsprozess würden Sie für das genannte Vorhaben wählen? Beschreiben Sie diesen ausführlich und begründen Sie Ihre Wahl!**
---
Für dieses Unterfangen, würde ich ein Projektteam mit ungefähr 6-8 Personen wählen. Durch die nicht sonderlich komplexe Art solch eines Projektes benötigt es meiner Meinung nach keine besonderen Experten, sicherlich sind allerdings beiläufige Prozesse wie Sicherheit und Usability von den Projekt-Mitgliedern zu beachten. Falls das Projekt-Team laut Einschätzung derer nicht genügend Kompetenzen auf den nicht-funktionalen Anforderungen aufbringen können, würde ich einen weiteren Experten einholen um diese korrekt umzusetzen.

Durch die relativ statische Natur einer Management-Software für eine Hotelkette, und die damit einkehrenden recht stabilen Anforderungen, würde ich mich für traditionelles Projektmanagement entscheiden. Weiters sind die Anforderungen sehr “breit”, damit sei gemient, dass es nicht leicht ist einfach schnell einen Prototypen zu bauen, da viele Funktionalitäten abgedeckt sein müssen, womit Techniken wie Scrum und Extreme Programming eher ungeeigneter scheinen. Als traditionellen Prozess würde ich mich für ein V-Modell entscheiden, da die Anforderungen vom Kunden klar definiert sind und dadurch weniger Zeit verwendet werden muss um Prototypen zu erstellen. Weiters ist das Testen im V-Modell stark vertreten, dies hilft besonders dabei im zeitlichen Rahmen von 6 Monaten zu bleiben. Es bleibt allerdings noch der Fakt, dass die statische Natur des V-Modells Änderungen bezüglich Feedback oder sonstige Änderungen schwer ermöglicht und schnell das Projekt scheitern lassen könnte bezüglich Ressourcen-Einsatz (Zeit und Geld).
---
**Erstellen Sie für das skizzierte Vorhaben ein Konzept zur Qualitätssicherung! Begründen Sie warum Sie welche Softwarequalitätssicherungsmethode in Ihrem Projekt anwenden.**
---
Wie bereits erwähnt wäre im meiner Wahl des Software-Entwicklungs Prozesses Testen schon tief eingettet, dadurch findet schon eine gewisse Art der dynamischen analytischen Qualitätssicherung statt. Dies kann noch weiter verfestigt werden, indem auch die zwei goldenen Regeln von Kent Beck bezüglich Test-driven-development verfolgt werden: 1) Business-Code wird erst geschrieben nach gefailtem Test und 2) Duplikate aus dem Code entfernen. Bezüglich der statischen Qualitätssicherung werden sicherlich moderne Tools wie IntelliJ verwendet, welche mittels verschiedenen Code-Metriken fehler beseitigen können.


Besonders durch die Wahl eines traditionellen Projektmanagement-Stils werden organisatorische Maßnahmen bei der Qualitätssicherung helfen. Dokumente bezüglich der Anforderungen und deren Traceability werden geführt, Checklisten bezüglich Tests oder gewissen Prozessen wie Security und Usability sind anzuführen, aber auch Knowledge-Bases bezüglich Erkenntnisse sollten geführt werden.
---
**Beschreiben Sie einen alternativen Softwareentwicklungsprozess ausführlich. Wenn Sie sich in 2.1 für einen agilen Prozess entschieden haben, beschreiben Sie einen Traditionellen. Sollten Sie sich in 2.1 für einen traditionellen Prozess entschieden haben, so wählen Sie nun einen Agilen. **
---
Als agilen Prozess für solch ein Projekt würde ich mich klassischerweiser für Scrum entscheiden. Im Endeffekt würde meine Entscheidung zwischen SCRUM und Kanban fallen, wobei Kanban in meinen Augen zu “dynamisch” für die Anforderungen des Kunden sind. XP ist gar nicht in meinen Erwägungen, da es eindeutig zu extreme für solch eine konservative Software ist, meiner Meinung nach. Mit Scrum als agiles Projektmanagement wird der Kunde mehr involviert sein, im Besonderen durch Einholung von Feedback nach Sprints und deren resultierende Prototypen, und teilweise auch in den sich immer wiederholenden Meetings. Wichtig für solch ein Projekt, besonders wenn es in 6 Monaten fertig sein soll, von Anfang an eine saubere Work-Breakdown-Structure zu erzeugen, und auch ggf. Anpassungen in den Sprint-Terminen und Umfängen durchzuführen falls das Projekt nicht dem Plan folgt, damit es wirklich in 6 Monaten “fertig” sein kann. 
---
Optimales Projektteam wählen (ohne ein Vorgehensmodell zu beschreiben). Welche Teamgröße? Welche Expertisen, warum?
---
Optimalerweise würde ich für solch ein Unterfangen ein Team aus ungefähr 6-8 Personen wählen. Wenn ein agiler Prozess gewählt wird, gäbe es sicherlich einen Product Owner und Scrum Master, bei einem traditionellen Prozess einen Projektleiter. Sicherlich müsste es festgelegte Personen geben für Komptenzen wie Usability (=> UX-Engineer), Testen (Test-Leader) und Sicherheit (=> Security-Officer). Weiters ist es wichtig, dass das Team selbständig arbeiten kann, sich mit dem Projekt identifiziert, Spaß daran hat und auch cross-funktional ist.

Bezüglich der Expertisen, habe ich explizit Usability, Testing und Security herausgehoben, wie bereits erwähnt können diese Felder entweder direkt durch das Team durch Verteilung von Verantwortung umgesetzt werden oder es können auch externe Experten zu Rate gezogen werden. Usability ist sicherlich relevant, da vom Kunden keine Anforderung bezüglich dessen gestellt wurde, und somit “in freier Schwebe” steht wie das Endprodukt konkret zu verwenden ist. Testing ist auch in einem eher nicht-kritischen Projekt (=> nicht überlebenskritisch) wichtig, da ein Ausfall der Software bedeutet, dass es keine temporär keine Einnahmen gibt. Weiters würde ich auch Security nicht auf die leichte Schulter nehmen, da viele personenzentrierte Daten gespeichert werden - wer ein Hotel bucht, wann sie es buchen, wie viel sie zahlen, evtl Kreditkarten-Informationen, etc.
---
**Agil vs. Klassisches Modell. Beschreiben was man eher nehmen müsste, argumentieren mittels Kriterien von den Folien. Es musste kein konkretes Modell beschrieben werden.**
---
Kriterien: PDCCS
Personnel
In einem agilen Modell ist zu beachten, dass den Entwickler:innen mehr Eigenverantwortung zugeschrieben wird. In den Folien wird angedacht, nicht fixiert, dass in einem agilen Entwicklungsprozess ein “qualifzierteres” Team benötigt wird. Meiner Meinung nach würde ich als Projektteam sowieso ein qualifiziertes, selbständig, kritisch denkendes Team wählen, deswegen würde dieses Kriterium nicht stark in die Entscheidung einfließen.
Dynamism
Die funktionalen Anforderungen des Projektes scheinen recht stabil zu sein. Wahre stabile Anforderungen gibt es nie, deswegen ist immer mit kleinen Änderungen zu rechnen, aber im Großen und Ganzen sollten sich die Anforderungen des Kunden nicht mehr ändern. Dies spricht eher für einen traditionellen Entwicklungsprozess, da dieser eher für Projekte mit einem recht fixem Rahmen gedacht ist.
Culture
Von der Kultur her ist meiner Meinung nach kein Stil des Projektmanagements vorzuziehen. Sicherlich ist in solch einer Branche Zuverlässigkeit und eine gewisse Art von Konservität zu rechnen, allerdings sind diese Werte durch beide agile und traditionelle Modelle vertreten. 
Criticality
Wie schon bereits erwähnt, handelt es sich bei dieser Software um keine überlebens-kritische Software, d.h. es hängen keine Menschenleben vom Unterfangen ab. Allerdings ist doch in Erwägung zu ziehen, dass der Kunde seinen Unterhalt mit dem Hotel finanziert, deswegen ist doch sicherzugehen, dass die Software möglichst zuverlässig läuft, da sonst die eventuell einzige Einnahmequelle verschwindet.
Size
Durch das eher kleine Projektteam von 6-8 Personen, ist es eventuell effizienter agil zu arbeiten. Für große Projekte (~50-100 Entwickler:innen) ist es eventuell besser traditionell zu arbeiten, da die eher starreren Strukturen einen besseren Überblick über die Komplexität geben.
 
-> Ich würde einen agilen Prozess wählen, da es sich um ein eher kleineres Projekt handelt, und keines der angegeben Kriterien ausschlaggebend ist für einen gewissen Prozess-Stil. Ein agiles Modell ist flexibler und hat etwas weniger Overhead, was in diesem Projekt sicherlich hilfreich ist.
---
**Aus der Angabe fünf nicht-funktionale Anforderungen ableiten und beschreiben.**
---
1. Das System darf in 365d*24h nur maximal 48 Stunden ausfallen
  Wie bereits erwähnt handelt es sich um keine überlebenswichtige Software, deswegen ist es vertrebar kleine Ausfälle zu haben. Allerdings darf es im ganzen Jahr nicht öfters als 2 Tage ausfallen insgesamt, um dem Einkommen des zugehörigen Unternehmens nicht zu schaden.

2. Passwörter und Kreditkarten-Informationen müssen zusammen mit einem Salt gehashed werden
  Es muss eine Zusatzmaßnahme zu den Security-Maßnahmen geben, falls es doch zu einem Data-Leak kommen sollte, nicht kritische Personen-Daten zu veröffentlichen
3. Nach einem Klick auf der Website muss **irgendein** Ergebnis innerhalb von 0,5s ersichtlich sein
  Wichtig: Mit **irgendein** Ergebnis, kann auch ein Ladebalken gemeint sein. Es ist nur wichtig, dass die Seite dem User gegenüber schnell und responsive gegenübersteht und somit keine Frustrationen auslöst
4. Die Software muss mindestens 50 weitere voll ausgestatte Standard Filialen unterstützen samt Buchungen auf dieser
  Wenn die Hotelkette skaliert, dadurch dass die Kundschaft sich verzehnfacht aufgrund der tollen Software, soll das System dieses unterstützen können ohne Ausfällen. Dies muss sowohl software-technisch als auch hardware-technisch gewährleistet sein und auch durch dementprechende Tests getestet werden.
5. Das Erscheinungsbild des Systems (gegenüber den User) muss modern sein und dem Branding-Image des Kunden entsprechen
  Diese nicht-funktionale Anforderung wurde in der Angabe nicht spezifiziert, ist jedoch sicherlich sehr wichtig zu beachten.